Index: branches/src/ProcessManagement/ProcessManagement/DB/IOAccess/IOProcessApprovalDetail.cs
===================================================================
--- branches/src/ProcessManagement/ProcessManagement/DB/IOAccess/IOProcessApprovalDetail.cs	(nonexistent)
+++ branches/src/ProcessManagement/ProcessManagement/DB/IOAccess/IOProcessApprovalDetail.cs	(revision 51)
@@ -0,0 +1,439 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Collections;
+
+using log4net;
+using MySql.Data.MySqlClient;           // Data Provider for MySql
+
+using ProcessManagement.DB.MySql;
+using ProcessManagement.DB.Core;
+using ProcessManagement.DataModel;
+
+using ProcessManagement.Common;
+
+namespace ProcessManagement.DB.IOAccess
+{
+    /// <summary>
+    /// 承認データアクセスクラス
+    /// </summary>
+    public class IOProcessApprovalDetail : MySqlProcess
+    {
+        #region 定義部
+        /// <summary>
+        /// log4netログを使用する
+        /// </summary>
+        private static readonly ILog logger = LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);
+        #endregion
+
+        #region 定数
+        /// <summary>
+        /// 承認データフィールド並び
+        /// </summary>
+        public enum ColumnName
+        {
+            ConstructionCode,
+            ApprovalCode,
+            OrderNo,
+            SerialNo,
+            LinkCode,
+            ENTRY_DATE,
+            UPDATE_DATE
+        }
+        #endregion
+
+        #region コンストラクタ
+        /// <summary>
+        /// コンストラクタ
+        /// </summary>
+        /// <param name="ConnectionString"></param>
+        public IOProcessApprovalDetail()
+            : base(DBCommon.Instance.DBConnectString)
+        {
+        }
+
+        #endregion
+
+        #region 承認データ検索文字列作成
+        /// <summary>
+        /// 承認データ検索文字列作成
+        /// </summary>
+        /// <param name="AddSQLString">検索条件SQL文字列</param>
+        /// <param name="data">承認データデータ</param>
+        /// <returns>true：成功 false：失敗</returns>
+        private string CreateSelectSQL()
+        {
+            // SQL作成
+            string strcmd = "SELECT";
+            strcmd += " ConstructionCode";
+            strcmd += ",ApprovalCode";
+            strcmd += ",OrderNo";
+            strcmd += ",SerialNo";
+            strcmd += ",LinkCode";
+            strcmd += ",DATE_FORMAT(EntryDate, '%Y/%m/%d %H:%i:%s')";
+            strcmd += ",DATE_FORMAT(UpdateDate, '%Y/%m/%d %H:%i:%s')";
+            strcmd += " FROM ProcessApprovalDetail";
+
+            return strcmd;
+        }
+        #endregion
+
+        #region 承認データ検索（複数）
+        /// <summary>
+        /// 承認データ検索（複数）
+        /// </summary>
+        /// <param name="AddSQLString"></param>
+        /// <param name="data"></param>
+        /// <param name="bConnect"></param>
+        /// <returns></returns>
+        public bool SelectAction(string AddSQLString, ref List<ProcessApprovalDetail> data, bool bConnect = true)
+        {
+            // インターフェース
+            string strcmd = "";
+            ArrayList arData = new ArrayList();
+
+            try
+            {
+                // SQL作成
+                strcmd = CreateSelectSQL() + AddSQLString;
+
+                // SQL実行
+                if (!ExecuteReader(strcmd, ref arData, bConnect)) return false;
+
+                // データセット
+                foreach (object[] objwrk in arData)
+                {
+                    ProcessApprovalDetail work = new ProcessApprovalDetail();
+                    Reader2Struct(objwrk, ref work);
+                    data.Add(work);
+                }
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}：{2}", CommonMotions.GetMethodName(2), ex.Message, strcmd);
+                return false;
+            }
+
+        }
+        #endregion
+
+        #region 承認データ検索（1件）
+        /// <summary>
+        /// 承認データ検索（1件）
+        /// </summary>
+        /// <param name="AddSQLString"></param>
+        /// <param name="data"></param>
+        /// <param name="bConnect"></param>
+        /// <returns></returns>
+        public bool SelectAction(string AddSQLString, ref ProcessApprovalDetail data, bool bConnect = true)
+        {
+            // インターフェース
+            string strcmd = "";
+            ArrayList arData = new ArrayList();
+
+            try
+            {
+                // SQL作成
+                strcmd = CreateSelectSQL() + AddSQLString;
+
+                // SQL実行
+                if (!ExecuteReader(strcmd, ref arData, bConnect)) return false;
+                if (arData.Count == 0) return false;
+
+                // データセット
+                object[] objwrk = (object[])arData[0];
+                Reader2Struct(objwrk, ref data);
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}：{2}", CommonMotions.GetMethodName(2), ex.Message, strcmd);
+                return false;
+            }
+
+        }
+        #endregion
+
+        #region 承認データ追加（複数）
+        /// <summary>
+        /// 承認データ追加（複数）
+        /// </summary>
+        /// <param name="data">承認データデータ</param>
+        /// <returns>true：成功 false：失敗</returns>
+        public bool InsertAction(List<ProcessApprovalDetail> data, bool bConnect = true)
+        {
+            string strcmd = "";
+            try
+            {
+                foreach (ProcessApprovalDetail work in data)
+                {
+                    if (!InsertAction(work, bConnect)) return false;
+                }
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}：{2}", CommonMotions.GetMethodName(2), ex.Message, strcmd);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 承認データ追加（1件）
+        /// <summary>
+        /// 承認データ追加（1件）
+        /// </summary>
+        /// <param name="data"></param>
+        /// <param name="bConnect"></param>
+        /// <returns></returns>
+        public bool InsertAction(ProcessApprovalDetail data, bool bConnect = true)
+        {
+            string strcmd = "";
+            try
+            {
+
+                    strcmd = "INSERT INTO ProcessApprovalDetail";
+                    strcmd += " (ConstructionCode";
+                    strcmd += ",ApprovalCode";
+                    strcmd += ",OrderNo";
+                    strcmd += ",SerialNo";
+                    strcmd += ",LinkCode";
+                    strcmd += ",EntryDate";
+                    strcmd += ",UpdateDate)";
+
+                    strcmd += " VALUES (";
+
+                    strcmd += string.Format("  {0}", data.ConstructionCode.ToString());
+                    strcmd += string.Format(", {0}", data.ApprovalCode.ToString());
+                    strcmd += string.Format(", {0}", data.OrderNo.ToString());
+                    strcmd += string.Format(", {0}", data.SerialNo.ToString());
+                    strcmd += string.Format(", {0}", data.LinkCode.ToString());
+
+                    strcmd += ", STR_TO_DATE(DATE_FORMAT(NOW(),'%Y/%m/%d %H:%i:%s'),'%Y/%m/%d %H:%i:%s')";
+                    strcmd += ", STR_TO_DATE(DATE_FORMAT(NOW(),'%Y/%m/%d %H:%i:%s'),'%Y/%m/%d %H:%i:%s')";
+                    strcmd = strcmd + ")";
+
+                    if (!ExecuteNonQuery(strcmd, bConnect)) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}：{2}", CommonMotions.GetMethodName(2), ex.Message, strcmd);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 承認データ更新
+        /// <summary>
+        /// 承認データ更新
+        /// </summary>
+        /// <param name="AddSQLString">更新条件SQL文字列</param>
+        /// <param name="data">承認データデータ</param>
+        /// <returns>true：成功 false：失敗</returns>
+        public bool UpdateAction(string AddSQLString, ProcessApprovalDetail data, bool bConnect = true)
+        {
+            string strcmd = "";
+            try
+            {
+
+                strcmd = "UPDATE ProcessApprovalDetail";
+
+                strcmd += " SET";
+
+                strcmd += string.Format(" ConstructionCode = {0}", data.ConstructionCode.ToString());
+                strcmd += string.Format(",ApprovalCode = {0}", data.ApprovalCode.ToString());
+                strcmd += string.Format(",OrderNo = {0}", data.OrderNo.ToString());
+                strcmd += string.Format(",SerialNo = {0}", data.SerialNo.ToString());
+                strcmd += string.Format(",LinkCode = {0}", data.LinkCode.ToString());
+
+                strcmd += ", UpdateDate = STR_TO_DATE(DATE_FORMAT(NOW(),'%Y/%m/%d %H:%i:%s'),'%Y/%m/%d %H:%i:%s')";
+                strcmd += AddSQLString;
+
+                if (!ExecuteNonQuery(strcmd, bConnect)) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}：{2}", CommonMotions.GetMethodName(2), ex.Message, strcmd);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 承認データ削除
+        /// <summary>
+        /// 承認データ削除
+        /// </summary>
+        /// <param name="AddSQLString">削除条件SQL文字列</param>
+        /// <param name="data">承認データデータ</param>
+        /// <returns>true：成功 false：失敗</returns>
+        public bool DeleteAction(string AddSQLString, bool bConnect = true)
+        {
+            // インターフェース
+            string strcmd = "";
+            try
+            {
+                strcmd = string.Format("{0}{1}", "DELETE FROM ProcessApprovalDetail", AddSQLString);
+
+                if (!ExecuteNonQuery(strcmd, bConnect)) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}：{2}", CommonMotions.GetMethodName(2), ex.Message, strcmd);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 1項目更新処理
+        /// <summary>
+        /// 1項目の更新を行う
+        /// </summary>
+        /// <returns></returns>
+        public bool UpdateFeild(int ConstructionCode, int FeildNo, object value, bool bConnect = true, int ApprovalCode = 0, int OrderNo = 0, int SeqNo = 0)
+        {
+            string strcmd = "";
+            try
+            {
+                strcmd = "UPDATE ProcessApprovalDetail";
+
+                strcmd += " SET";
+                switch (FeildNo)
+                {
+                    case (int)ColumnName.ConstructionCode:
+                        strcmd += string.Format(" ConstructionCode = {0}", ((int)value).ToString());
+                        break;
+                    case (int)ColumnName.ApprovalCode:
+                        strcmd += string.Format(" ApprovalCode = {0}", ((int)value).ToString());
+                        break;
+                    case (int)ColumnName.OrderNo:
+                        strcmd += string.Format(" OrderNo = {0}", ((int)value).ToString());
+                        break;
+                    case (int)ColumnName.SerialNo:
+                        strcmd += string.Format(" SerialNo = {0}", ((int)value).ToString());
+                        break;
+                    case (int)ColumnName.LinkCode:
+                        strcmd += string.Format(" PersonCode = {0}", ((int)value).ToString());
+                        break;
+                }
+
+                strcmd += ", UpdateDate = STR_TO_DATE(DATE_FORMAT(NOW(),'%Y/%m/%d %H:%i:%s'),'%Y/%m/%d %H:%i:%s')";
+                strcmd += CreatePrimarykeyString(ConstructionCode, ApprovalCode, OrderNo, SeqNo);
+
+                if (!ExecuteNonQuery(strcmd, bConnect)) return false;
+
+                return true;
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}：{2}", CommonMotions.GetMethodName(2), ex.Message, strcmd);
+                return false;
+            }
+        }
+        #endregion
+
+        #region 構造体へセットする
+        /// <summary>
+        /// 構造体へセットする
+        /// </summary>
+        /// <param name="wrk">構造体</param>
+        public void Reader2Struct(object[] objwrk, ref ProcessApprovalDetail wrk)
+        {
+            try
+            {
+                // データ取得
+                wrk.ConstructionCode = int.Parse(objwrk[(int)ColumnName.ConstructionCode].ToString());
+                wrk.ApprovalCode = int.Parse(objwrk[(int)ColumnName.ApprovalCode].ToString());
+                wrk.OrderNo = int.Parse(objwrk[(int)ColumnName.OrderNo].ToString());
+                wrk.SerialNo = int.Parse(objwrk[(int)ColumnName.SerialNo].ToString());
+                wrk.LinkCode = int.Parse(objwrk[(int)ColumnName.LinkCode].ToString());
+
+                wrk.EntryDate = DateTime.Parse(objwrk[(int)ColumnName.ENTRY_DATE].ToString());
+                wrk.UpdateDate = DateTime.Parse(objwrk[(int)ColumnName.UPDATE_DATE].ToString());
+            }
+            catch (MySqlException myex)
+            {
+                logger.ErrorFormat("ＭｙＳＱＬエラー：{0}：{1}", CommonMotions.GetMethodName(), myex.Message);
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}", CommonMotions.GetMethodName(), ex.Message);
+            }
+        }
+        #endregion
+
+        #region 主キー検索の文字列を返す
+        /// <summary>
+        /// 主キー検索の文字列を返す
+        /// </summary>
+        /// <param name="BusinessTypeCode"></param>
+        /// <returns>Where文字列</returns>
+        public string CreatePrimarykeyString(int ConstructionCode, int ApprovalCode = 0, int OrderNo = 0, int SerialNo = 0, string APara = "")
+        {
+            string strWork = string.Empty;
+            try
+            {
+                strWork = string.Format(" Where {0}ConstructionCode = {1}", APara, ConstructionCode.ToString());
+                if (ApprovalCode != 0)
+                    strWork += string.Format(" And {0}ApprovalCode = {1}", APara, ApprovalCode.ToString());
+                if (OrderNo != 0)
+                    strWork += string.Format(" And {0}OrderNo = {1}", APara, OrderNo.ToString());
+                if (SerialNo != 0)
+                    strWork += string.Format(" And {0}SerialNo = {1}", APara, SerialNo.ToString());
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}：{2}", CommonMotions.GetMethodName(2), ex.Message, strWork);
+            }
+
+            return strWork;
+        }
+        #endregion
+
+        #region 枝番の最大値を取得する
+        /// <summary>
+        /// 枝番の最大値を取得する
+        /// </summary>
+        /// <returns></returns>
+        public int MaxSerialNoCount(string AddSQLString, bool bConnect = true)
+        {
+            // インターフェース
+            string strcmd = "";
+            ArrayList arData = new ArrayList();
+            int iRet = 0;
+            try
+            {
+                // SQL作成
+                strcmd = "SELECT IFNULL(MAX(SerialNo), 0) FROM ProcessApprovalDetail" + AddSQLString;
+
+                // SQL実行
+                if (!ExecuteReader(strcmd, ref arData, bConnect)) return iRet;
+
+                // データセット
+                foreach (object[] objwrk in arData)
+                {
+                    if (objwrk[0].ToString().Equals("null"))
+                        iRet = 0;
+                    else
+                        iRet = int.Parse(objwrk[0].ToString());
+                }
+
+            }
+            catch (Exception ex)
+            {
+                logger.ErrorFormat("システムエラー：{0}：{1}：{2}", CommonMotions.GetMethodName(2), ex.Message, strcmd);
+            }
+            return iRet;
+        }
+        #endregion
+    }
+}
